commit 56c22660f61b6d05297fab819820dd59b0f109e5
Author: freddy77 <freddy77>
Date:   Mon Jul 19 11:52:15 2010 +0000

    fix connect test for windows

diff --git a/ChangeLog b/ChangeLog
index a49531b..e4616d3 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jul 19 13:51:50 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/Makefile.am src/odbc/unittests/connect.c:
+	- fix connect test for windows
+
 Mon Jul 19 12:05:46 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/blk.c:
 	- applied patch from Shatam Bhattacharya for blk_rowxfer
@@ -2705,4 +2709,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3080 2010/07/19 10:06:07 freddy77 Exp $
+$Id: ChangeLog,v 1.3081 2010/07/19 11:52:15 freddy77 Exp $
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 8675be9..f38b57b 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.82 2010/03/02 15:41:37 freddy77 Exp $
+# $Id: Makefile.am,v 1.83 2010/07/19 11:52:15 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -32,6 +32,7 @@ t0002_SOURCES	=	t0002.c common.c common.h
 t0003_SOURCES	=	t0003.c common.c common.h
 t0004_SOURCES	=	t0004.c common.c common.h
 connect_SOURCES	=	connect.c common.c common.h
+connect_LDFLAGS = $(ODBCINSTLIB)
 print_SOURCES	=	print.c common.c common.h
 date_SOURCES	=	date.c common.c common.h
 norowset_SOURCES	= norowset.c common.c common.h
diff --git a/src/odbc/unittests/connect.c b/src/odbc/unittests/connect.c
index 99090fa..e0cc2e7 100644
--- a/src/odbc/unittests/connect.c
+++ b/src/odbc/unittests/connect.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: connect.c,v 1.13 2010/07/05 09:20:32 freddy77 Exp $";
+static char software_version[] = "$Id: connect.c,v 1.14 2010/07/19 11:52:15 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -13,12 +13,30 @@ init_connect(void)
 	CHKAllocConnect(&odbc_conn, "S");
 }
 
+#ifdef _WIN32
+#include <odbcinst.h>
+
+static char *entry = NULL;
+
+static char *
+get_entry(const char *key)
+{
+	static char buf[256];
+
+	entry = NULL;
+	if (SQLGetPrivateProfileString(odbc_server, key, "", buf, sizeof(buf), "odbc.ini") > 0)
+		entry = buf;
+
+	return entry;
+}
+#endif
+
 int
 main(int argc, char *argv[])
 {
 	char tmp[2048];
 	SQLSMALLINT len;
-	int failures = 0;
+	int succeeded = 0;
 	int is_freetds = 1;
 	SQLRETURN rc;
 
@@ -49,6 +67,7 @@ main(int argc, char *argv[])
 	if (!odbc_driver_is_freetds())
 		is_freetds = 0;
 	odbc_disconnect();
+	++succeeded;
 
 	if (!is_freetds) {
 		printf("Driver is not FreeTDS, exiting\n");
@@ -61,6 +80,7 @@ main(int argc, char *argv[])
 	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;", odbc_server, odbc_user, odbc_password, odbc_database);
 	CHKDriverConnect(NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT, "SI");
 	odbc_disconnect();
+	++succeeded;
 
 	/* try connect string using old SERVERNAME specification */
 	printf("connect string SERVERNAME connect..\n");
@@ -72,7 +92,8 @@ main(int argc, char *argv[])
 	rc = CHKDriverConnect(NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT, "SIE");
 	if (rc == SQL_ERROR) {
 		printf("Unable to open data source (ret=%d)\n", rc);
-		++failures;
+	} else {
+		++succeeded;
 	}
 	odbc_disconnect();
 
@@ -82,13 +103,30 @@ main(int argc, char *argv[])
 	rc = CHKDriverConnect(NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT, "SIE");
 	if (rc == SQL_ERROR) {
 		printf("Unable to open data source (ret=%d)\n", rc);
-		++failures;
+	} else {
+		++succeeded;
 	}
 	odbc_disconnect();
 
+#ifdef _WIN32
+	if (get_entry("SERVER")) {
+		init_connect();
+		sprintf(tmp, "DRIVER=FreeTDS;SERVER=%s;UID=%s;PWD=%s;DATABASE=%s;", entry, odbc_user, odbc_password, odbc_database);
+		if (get_entry("TDS_Version"))
+			sprintf(strchr(tmp, 0), "TDS_Version=%s;", entry);
+		rc = CHKDriverConnect(NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT, "SIE");
+		if (rc == SQL_ERROR) {
+			printf("Unable to open data source (ret=%d)\n", rc);
+		} else {
+			++succeeded;
+		}
+		odbc_disconnect();
+	}
+#endif
+
 	/* at least one should success.. */
-	if (failures > 1) {
-		ODBC_REPORT_ERROR("Too much failures");
+	if (succeeded < 3) {
+		ODBC_REPORT_ERROR("Too few successes");
 		exit(1);
 	}
 

